#include "sale.h"

#include <numeric>

void Sale::addArticle(std::shared_ptr<Article> articlePtr)
{
    articlePtr->setSale(this);
    articles_.push_back(articlePtr);
}

void Sale::removeArticle(const Article* articlePtr)
{
    auto it = std::find_if(articles_.begin(), articles_.end(),
                           [&articlePtr](auto art) { return art.get() == articlePtr; });
    if (it != articles_.end()) {
        (*it)->setSale(nullptr);
        articles_.erase(it);
    }
}

int Sale::sumInCents()
{
    int sum = std::accumulate(articles_.begin(), articles_.end(), 0,
                              [](int a, std::shared_ptr<Article> b) { return a + b->getPrice(); });
    return sum;
}